Version:       1.1.1
%global forgeurl https://gitlab.com/libblkio/libblkio
%global tag    v%{version}
%forgemeta

Summary:       Block device I/O library
Name:          libblkio
Release:       7%{?dist}
URL:           %{forgeurl}
Source0:       %{forgesource}
License:       Apache-2.0 OR MIT

# Fix for meson 0.64
# (https://gitlab.com/libblkio/libblkio/-/merge_requests/149)
Patch:         149.patch

# Basic build requirements.
BuildRequires: gcc, gcc-c++
BuildRequires: make
BuildRequires: meson
BuildRequires: rust-packaging >= 21
BuildRequires: rustfmt
BuildRequires: cargo
BuildRequires: python3-docutils
BuildRequires: pkgconf
BuildRequires: crate(autocfg/default)
BuildRequires: crate(bitflags/default)
BuildRequires: crate(cc/default)
BuildRequires: crate(cfg-if/default)
BuildRequires: crate(concat-idents/default)
BuildRequires: crate(const-cstr/default)
BuildRequires: crate(io-uring/default)
BuildRequires: crate(lazy_static/default)
BuildRequires: crate(libc/default)
BuildRequires: crate(memmap2/default)
BuildRequires: crate(nix/default)
BuildRequires: crate(num-traits/default)
BuildRequires: crate(pci-driver/default)
BuildRequires: crate(proc-macro2/default)
BuildRequires: crate(quote/default)
BuildRequires: crate(syn/default)
BuildRequires: crate(unicode-xid/default)
BuildRequires: crate(virtio-bindings/default)


%description
libblkio is a library for high-performance block device I/O with
support for multi-queue devices. A C API is provided so that
applications can use the library from most programming languages.


%package devel
Summary:       Development tools for %{name}
Requires:      %{name}%{_isa} = %{version}-%{release}


%description devel
This package contains development tools for %{name}.


%prep
%forgeautosetup -p1

%cargo_prep
sed -e 's/--locked/--offline/' -i src/cargo-build.sh

%build
%{meson}
%{meson_build}


%install
%{meson_install}


%files
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_libdir}/libblkio.so.1*


%files devel
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_includedir}/blkio.h
%{_libdir}/libblkio.so
%{_libdir}/pkgconfig/blkio.pc
%{_mandir}/man3/blkio.3*


%changelog
* Wed Nov 23 2022 Richard W.M. Jones <rjones@redhat.com> - 1.1.1-7
- Initial package
